<!DOCTYPE html>
<html>
	<body>
		<p>Click the button to show all behaviour of linked list.</p>
		<button onclick="linked_List()">Linked List</button>
		<p id="demo"></p>

		<script>
			function linked_List() {
                // User defined class node 
                class Node { 
                    // constructor 
                    constructor(element) 
                    { 
                        this.element = element; 
                        this.next = null
                    } 
                } 

                // linkedlist class 
                class LinkedList { 
                    constructor() { 
                        this.head = null; 
                        this.size = 0; 
                    }   

                    // adds an element at the end of list 
                    add(element) { 
                        // creates a new node 
                        var node = new Node(element); 
    
                        // to store current node 
                        var current; 
    
                        // if list is Empty add the element and make it head 
                        if (this.head == null) 
                            this.head = node; 
                        else {
                            current = this.head; 
    
                            // iterate to the end of the list 
                            while (current.next) { 
                                current = current.next; 
                            } 
                            // add node 
                            current.next = node;  
                            this.size++; 
                        }
                    }
   

                    // prints the list items 
                    printList() { 
                        var curr = this.head; 
                        var str = ""; 
                        while (curr) { 
                            str += curr.element + " "; 
                            curr = curr.next; 
                        } 
                        console.log(str); 
                    } 

                    swapNodes(x,y) { 
                        // Nothing to do if x and y are same 
                        if (x == y) return; 
                
                        // Search for x (
                        var prevX = null, currX = this.head; 
                        while (currX != null && currX.element != x) { 
                            prevX = currX; 
                            currX = currX.next; 
                        } 
                
                        // Search for y 
                        var prevY = null, currY = this.head; 
                        while (currY != null && currY.element != y) { 
                            prevY = currY; 
                            currY = currY.next; 
                        } 
                        // If either x or y is not present, nothing to do 
                        if (currX == null || currY == null) 
                            return; 
                
                        // If x is not head of linked list 
                        if (prevX != null) 
                            prevX.next = currY; 
                        else //make y the new head 
                            this.head = currY; 
                
                        // If y is not head of linked list 
                        if (prevY != null) 
                            prevY.next = currX; 
                        else // make x the new head 
                            head = currX; 
                
                        // Swap next pointers 
                        var temp = currX.next; 
                        currX.next = currY.next; 
                        currY.next = temp; 
                    }

                }

                // creating an object for the Linkedlist class 
                var linked_list = new LinkedList(); 
                linked_list.add(10); 
                linked_list.add(20); 
                linked_list.add(30); 
                linked_list.add(40); 
                linked_list.add(50); 

                linked_list.printList(); 
                linked_list.swapNodes(20,30);
                linked_list.printList();

        }

		</script>

	</body>
</html>